Attribute VB_Name = "Module1"
'
'
'
'/// Type Declarations

Public Type lrect
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Public Type PointType
        x As Long
        y As Long
End Type

Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type


'/// Function and SUB Declares

Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function InvalidateRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT, ByVal bErase As Long) As Long
Declare Function BringWindowToTop Lib "user32" (ByVal hwnd As Long) As Long
Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long
Declare Function GetWindowWord Lib "user32" (ByVal hwnd As Long, ByVal nIndex As Long) As Integer
Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Declare Function GetDesktopWindow Lib "user32" () As Long
Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As lrect) As Long
Public Declare Function GetCursorPos Lib "user32" (lpPoint As PointType) As Long
Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Declare Function RedrawWindow Lib "user32" (ByVal hwnd As Long, lprcUpdate As Any, ByVal hrgnUpdate As Long, ByVal fuRedraw As Long) As Long

'/// Dimension Variables with scope

Global r As RECT
Global pointXY As PointType
Global TwipsPerPixel As Single
Global ScreenWidth As Long
Global ScreenHeight As Long
Global nWidth&
Global nHeight&
Global ptCursor As Long
Global Direction As Integer
Global hwndSrc&
Global Counter As Integer
Global Started As Integer
Global dwRop&
Global MouseCaptured
Global CaptureTimer
Global DebugMode As Integer
Global LastDirection As Integer
Global CurrentTime
Global TimerInterval
Global dX& ' pixel interval
Global IconPosition(25, 2) As Long
Global RunMode As Integer
Global RunModeTimer
Global IconStarted As Integer
Global IconCounter As Integer
Global IconRandomNumber As Integer
Global CurrentWindowCount As Integer
Global Const RDW_INVALIDATE = &H1
Global Const RDW_ALLCHILDREN = &H80
Global Const RDW_ERASE = &H4
Global ImageNumber As Integer
'  ShowWindow() Commands
Global Const SW_HIDE = 0
Global Const SW_SHOWNORMAL = 1
Global Const SW_NORMAL = 1
Global Const SW_SHOWMINIMIZED = 2
Global Const SW_SHOWMAXIMIZED = 3
Global Const SW_MAXIMIZE = 3
Global Const SW_SHOWNOACTIVATE = 4
Global Const SW_SHOW = 5
Global Const SW_MINIMIZE = 6
Global Const SW_SHOWMINNOACTIVE = 7
Global Const SW_SHOWNA = 8
Global Const SW_RESTORE = 9
Global Const WS_EX_TRANSPARENT = &H20&
Global Const GWL_EXSTYLE = (-20)
Const GWW_HINSTANCE = (-6)
Const GWW_ID = (-12)
Const GWL_STYLE = (-16)


Sub GetTwipsPerPixel()
' Set a global variable with the Twips to Pixel ratio.
      frmAnimate.ScaleMode = 3
      NumPix = frmAnimate.ScaleHeight
      frmAnimate.ScaleMode = 1
      TwipsPerPixel = frmAnimate.ScaleHeight / NumPix

End Sub

Sub GrabScreen()

'Now don't actually need to grab the whole screen
'TODO: just load our height and width vars
Dim winSize As lrect

      ' Assign information of the source bitmap.
      ' Note that BitBlt requires coordinates in pixels.
   
      hwndSrc = GetDesktopWindow()
      hSrcDC = GetDC(hwndSrc)
  
      xSrc = 0: ySrc = 0
      If Started = 0 Then
      somevar& = GetWindowRect(hwndSrc, winSize)
        
        nWidth = winSize.Right             ' Units in pixels.
        nHeight = winSize.Bottom           ' Units in pixels.
      Else
      End If
      ' Assign informate of the destination bitmap.
      hDestDC = frmAnimate.Picture1.hdc
      x = 0: y = 0

      ' Set global variable TwipsPerPixel and use to set
      ' picture box to same size as screen being grabbed.
      ' If picture box not the same size as picture being
      ' BitBlt'ed to it, it will chop off all that does not
      ' fit in the picture box.
      If Started = 0 Then
        GetTwipsPerPixel
        ScreenWidth = Screen.Width / Screen.TwipsPerPixelX
        ScreenHeight = Screen.Height / Screen.TwipsPerPixelY
        frmAnimate.Top = 0
        frmAnimate.Left = 0
        frmAnimate.Width = (nWidth + 1) * TwipsPerPixel
        frmAnimate.Height = (nHeight + 1) * TwipsPerPixel
        frmAnimate.Picture1.Top = 0
        frmAnimate.Picture1.Left = 0
        frmAnimate.Picture1.Width = (nWidth + 1) * TwipsPerPixel
        frmAnimate.Picture1.Height = (nHeight + 1) * TwipsPerPixel
      ' Assign the value of the constant SRCOPYY to the Raster operation.
      dwRop& = &HCC0020

    
      
        
      Else
      End If
    
      Suc = BitBlt(hDestDC, x, y, nWidth, nHeight, hSrcDC, xSrc, ySrc, dwRop&)

      Dmy& = ReleaseDC(hwndSrc, hSrcDC)

      'Make the picture box visible.
      'frmAnimate.Picture1.Visible = True


End Sub

